﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Data;
using CodeCampService.DAL;
using CodeCampService.BLL;

namespace CodeCampService.tests
{
    [TestClass]
    public class BLLTests
    {
        [TestMethod]
        public void TranslateProductDataRow()
        {
            IProductsDAO dao = new ProductsDAO();
            DataSet ds = dao.GetProducts();
            foreach (DataRow row in ds.Tables[0].Rows)
            {
                Product product = ProductTranslator.DataRowToProduct(row);
                Assert.IsTrue(product.ProductID != 0);
                Assert.IsNotNull(product.Name);
                Assert.IsNotNull(product.Model);
                Assert.IsNotNull(product.Description);     
            }
        }

        [TestMethod]
        public void GetProductList()
        {
            IProductProvider provider = new ProductProvider();
            IProductsDAO dao = new ProductsDAO();
            provider.ProductsDAO = dao;

            List<Product> products = provider.GetProducts();
            DataSet ds = dao.GetProducts();
            Assert.AreEqual(ds.Tables[0].Rows.Count, products.Count);
        }

    }
}
