﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using CodeCampService.Util;

namespace CodeCampService.BLL
{
    public static class ProductTranslator
    {
        public static Product DataRowToProduct(DataRow row)
        {
            Product product = new Product();
            product.ProductID = _ColToInt(row, ColumnNames.ProductID);
            product.Name = _ColToString(row, ColumnNames.Name);
            product.Model = _ColToString(row, ColumnNames.ProductModel);
            product.Description = _ColToString(row, ColumnNames.Description);
            return product;
            
        }

        private static string _ColToString(DataRow row, string columnName)
        {
            if (row.IsNull(columnName))
            {
                return string.Empty;
            }
            return row[columnName].ToString();
        }

        private static int _ColToInt(DataRow row, string columnName)
        {
            int val = 0;
            if (row.IsNull(columnName))
            {
                return val;
            }
            int.TryParse(row[columnName].ToString(), out val);
            return val;
        }
    }
}
