﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CodeCampService;
using System.ServiceModel;

namespace CustomPIABAspect
{
    class Program
    {
        static void Main(string[] args)
        {
            List<ServiceHost> serviceHosts = new List<ServiceHost>();
            
            AddService(serviceHosts, typeof(ProductService),
                new Uri("http://localhost:8000/CodeCampServices/ProductService.svc"),
                "CodeCampService.ProductService");
            
            // Close the ServiceHosts to shut down the services
            Console.WriteLine("Press ENTER to shut down services.");
            Console.ReadLine();

            foreach (ServiceHost host in serviceHosts)
            {
                host.Close();
            }
        }

        private static void AddService(List<ServiceHost> serviceHosts, Type serviceType, Uri baseAddress, string serviceName)
        {
            //Create host
            ServiceHost serviceHost = new ServiceHost(serviceType, baseAddress);

            // Open the ServiceHost to create listeners and start listening for messages.
            serviceHost.Open();
            serviceHosts.Add(serviceHost);
            // The service can now be accessed.
            Console.WriteLine("The service " + serviceName + " is ready.");
            Console.WriteLine("Running at address: " + baseAddress);
            Console.WriteLine();
        }
    }
}
