﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Practices.Unity.InterceptionExtension;
using CodeCampService;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.EnterpriseLibrary.PolicyInjection.Configuration;
using System.Collections.Specialized;

namespace CustomPIABAspect
{
    [ConfigurationElementType(typeof(CustomCallHandlerData))]
    public class CustomPIABAdvice : ICallHandler
    {

        public CustomPIABAdvice()
        {
            //DefaultConstructor for testing
        }

        public CustomPIABAdvice(NameValueCollection collection)
        {
            //PIAB Constructor
        }


        #region ICallHandler Members

        public IMethodReturn Invoke(IMethodInvocation input, GetNextHandlerDelegate getNext)
        {
            //Pre Processing Goes Here            

            IMethodReturn msg = getNext()(input, getNext);

            //Post Processing Goes Here
            List<Product> products = msg.ReturnValue as List<Product>;
            if (products != null && products.Count > 10)
            {
                products.RemoveRange(10, products.Count - 10);
                msg.ReturnValue = products;
            }

            return msg;

        }

        private int _Order;
        public int Order
        {
            get
            {
                return _Order;
            }
            set
            {
                _Order = value;
            }
        }

        #endregion



    }
}
