﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using CodeCampService.DAL;
using CustomPostSharpAspect;

namespace CodeCampService.BLL
{
    //[ProductLimit(Limit=10,AttributeTargetMembers="Get*")]
    public class DecoratedProductProvider : IProductProvider
    {
        private IProductsDAO _ProductsDAO = new ProductsDAO();
        public IProductsDAO ProductsDAO
        {
            get { return _ProductsDAO; }
            set { _ProductsDAO = value; }
        }

        [ProductLimit(Limit=10)]
        public List<Product> GetProducts()
        {
            List<Product> products = new List<Product>();
            foreach (DataRow row in ProductsDAO.GetProducts().Tables[0].Rows)
            {
                products.Add(ProductTranslator.DataRowToProduct(row));
            }
            return products;
        }
    }
}
