﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PostSharp.Laos;
using CodeCampService;

namespace CustomPostSharpAspect
{
    [Serializable]
    public class ProductLimitAttribute : OnMethodBoundaryAspect
    {
        private int _Limit = 0;
        public int Limit
        {
            get { return _Limit; }
            set { _Limit = value; }
        }
        
        public override void OnEntry(MethodExecutionEventArgs eventArgs)
        {
            
        }

        public override void OnExit(MethodExecutionEventArgs eventArgs)
        {
            if (Limit > 0)
            {
                List<Product> products = eventArgs.ReturnValue as List<Product>;
                if (products != null && products.Count > Limit)
                {
                    products.RemoveRange(Limit, products.Count - Limit);
                    eventArgs.ReturnValue = products;
                }
            }
        }
    }
}
