﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Spring.Context;
using Spring.Context.Support;
using CodeCampService.BLL;
using CodeCampService;

namespace CustomSpringAspect.Tests
{
    [TestClass]
    public class CustomSpringAspectTests
    {
        [TestMethod]
        public void CreateProductProvider()
        {
            IApplicationContext ctx = ContextRegistry.GetContext();
            IProductProvider provider = (IProductProvider) ctx["ProductProvider"];
            List<Product> products = provider.GetProducts();
            Assert.IsNotNull(products);
            Assert.AreNotEqual(0, products.Count);
        }

        [TestMethod]
        public void CreateProductProviderProxy()
        {
            IApplicationContext ctx = ContextRegistry.GetContext();
            IProductProvider provider = (IProductProvider)ctx["ProductProviderProxy"];
            List<Product> products = provider.GetProducts();
            Assert.IsNotNull(products);
            Assert.IsTrue(products.Count <= 10);
        }
    }
}
