using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;
using System.ServiceModel.Configuration;
using System.Runtime.Serialization;

namespace PolicyInjectionBehaviors
{
    public class PolicyInjectionBehaviorAttribute : Attribute, IContractBehavior, IContractBehaviorAttribute
    {

        public PolicyInjectionBehaviorAttribute()
        {
        }

        #region IContractBehaviorAttribute Members

        public Type TargetContract
        {
            get 
            { 
                //return null so we apply to all contracts
                return null; 
            }
        }

        #endregion

        #region IContractBehavior Members

        public void AddBindingParameters(ContractDescription description, ServiceEndpoint endpoint, System.ServiceModel.Channels.BindingParameterCollection parameters)
        {
            return;
        }

        public void ApplyClientBehavior(ContractDescription description, ServiceEndpoint endpoint, ClientRuntime clientRuntime)
        {
            return;
        }

        public void ApplyDispatchBehavior(ContractDescription description, ServiceEndpoint endpoint, DispatchRuntime dispatch)
        {
            Type contractType = description.ContractType;
            dispatch.InstanceProvider = new PolicyInjectionInstanceProvider(contractType);
        }

        public void Validate(ContractDescription description, ServiceEndpoint endpoint)
        {
            return;
        }

        #endregion
    }
 

    
}
