using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Configuration;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;
using System.Runtime.Serialization;

namespace PolicyInjectionBehaviors
{
    public class PolicyInjectionEndpointBehavior : BehaviorExtensionElement, IEndpointBehavior
    {

        public override Type BehaviorType
        {
            get { return typeof(PolicyInjectionEndpointBehavior); }
        }

        protected override object CreateBehavior()
        {
            return new PolicyInjectionEndpointBehavior();
        }

        #region IEndpointBehavior Members

        public void AddBindingParameters(ServiceEndpoint endpoint, System.ServiceModel.Channels.BindingParameterCollection bindingParameters)
        {
            //throw new Exception("The method or operation is not implemented.");
        }

        public void ApplyClientBehavior(ServiceEndpoint endpoint, ClientRuntime clientRuntime)
        {
            //throw new Exception("The method or operation is not implemented.");
        }

        public void ApplyDispatchBehavior(ServiceEndpoint endpoint, EndpointDispatcher endpointDispatcher)
        {
            Type contractType = endpoint.Contract.ContractType;
            endpointDispatcher.DispatchRuntime.InstanceProvider = new PolicyInjectionInstanceProvider(contractType);
        }

        public void Validate(ServiceEndpoint endpoint)
        {
            //throw new Exception("The method or operation is not implemented.");
        }

        #endregion
    }
}
